	
-- rMinimap: core
-- zork, 2016

-----------------------------
-- Variables
-----------------------------

local A, L = ...

L.addonName       = A
L.dragFrames      = {}
L.addonColor      = "00FFAA00"
L.addonShortcut   = "rmm"

-----------------------------
-- Config
-----------------------------

local cfg = {
  scale = 1,
  point = { "BOTTOMRIGHT", -22, 26},
}

-----------------------------
-- Init
-----------------------------

--MinimapCluster
MinimapCluster:SetScale(cfg.scale)
MinimapCluster:ClearAllPoints()
MinimapCluster:SetPoint(unpack(cfg.point))

--Minimap
local mediapath = "interface\\addons\\"..A.."\\media\\"
Minimap:SetMaskTexture(mediapath.."mask")
Minimap:ClearAllPoints()
Minimap:SetPoint("CENTER")
Minimap:SetSize(235,235) --correct the cluster offset

--hide regions
MinimapBackdrop:Hide()
MinimapBorder:Hide()
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
--MiniMapRecordingButton:Hide()
MinimapBorderTop:Hide()
MiniMapWorldMapButton:Hide()
MinimapZoneText:Hide()
MiniMapVoiceChatFrame:Hide()
GameTimeFrame:Hide()
MinimapZoneTextButton:Hide()
MiniMapTracking:Hide()
MiniMapMailBorder:Hide()
MinimapNorthTag:SetAlpha(0)
Minimap:SetArchBlobRingScalar(0)
Minimap:SetArchBlobRingAlpha(0)
Minimap:SetQuestBlobRingScalar(0)
Minimap:SetQuestBlobRingAlpha(0)
LoadAddOn'Blizzard_TimeManager'
local region = TimeManagerClockButton:GetRegions()
region:Hide()
TimeManagerClockButton:Hide()

-- durability
DurabilityFrame:Hide()
DurabilityFrame:SetAlpha(0)
DurabilityFrame:UnregisterAllEvents()

-- garrison/orderhall
GarrisonLandingPageMinimapButton:ClearAllPoints()
GarrisonLandingPageMinimapButton:SetParent(Minimap)
--GarrisonLandingPageMinimapButton:SetPoint('BOTTOMRIGHT', Minimap, 7, 24)
GarrisonLandingPageMinimapButton:SetPoint('BOTTOMRIGHT', Minimap, 4, 27)
GarrisonLandingPageMinimapButton:SetSize(46, 46)
hooksecurefunc('GarrisonLandingPageMinimapButton_UpdateIcon', function(self)
	self:SetNormalTexture('')
	self:SetPushedTexture('')
	self:SetHighlightTexture('')
	
	local icon = self:CreateTexture(nil,'OVERLAY',nil,7)
	icon:SetSize(42, 42)
	icon:SetPoint('CENTER')
	icon:SetTexture([[Interface/AddOns/rMinimap/media/garrison1]])
	icon:SetVertexColor(1, 1, 1, 0.4)
	self.icon = icon
end)

GarrisonLandingPageMinimapButton:SetScript('OnEnter', function(self)
	self.icon:SetVertexColor(1, 1, 1, 1)
end)

GarrisonLandingPageMinimapButton:SetScript('OnLeave', function(self)
	self.icon:SetVertexColor(1, 1, 1, 0.4)
end)
GarrisonMinimapBuilding_ShowPulse = function() end

--dungeon info
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint('TOPLEFT', Minimap, 0, -40)
MiniMapInstanceDifficulty:SetScale(0.8)
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetPoint('TOPLEFT', Minimap, 0, -40)
GuildInstanceDifficulty:SetScale(0.7)
MiniMapChallengeMode:ClearAllPoints()
MiniMapChallengeMode:SetPoint('TOPLEFT', Minimap, 0, -40)
MiniMapChallengeMode:SetScale(0.6)

--QueueStatusMinimapButton (lfi)
QueueStatusMinimapButton:SetParent(Minimap)
QueueStatusMinimapButton:SetScale(1)
QueueStatusMinimapButton:SetAlpha(1)
QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint('BOTTOMLEFT', Minimap, 0, 30)
QueueStatusMinimapButton:SetHighlightTexture (nil)
QueueStatusMinimapButton:SetPushedTexture(nil)
QueueStatusMinimapButtonBorder:SetTexture([[Interface/AddOns/rMinimap/media/queue]])
QueueStatusMinimapButtonBorder:SetPoint("TOPLEFT", QueueStatusMinimapButton, "TOPLEFT", 0, 0)
QueueStatusMinimapButtonBorder:SetPoint("BOTTOMRIGHT", QueueStatusMinimapButton, "BOTTOMRIGHT", 0, 0)
QueueStatusMinimapButtonBorder:SetVertexColor(1, 1, 1, 0)

--mail
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetParent(Minimap)
MiniMapMailFrame:SetFrameStrata'HIGH'
MiniMapMailFrame:SetPoint('TOPRIGHT', Minimap, 0, -30)	
MiniMapMailIcon:ClearAllPoints()
MiniMapMailIcon:SetTexture([[Interface/AddOns/rMinimap/media/mail]])
MiniMapMailIcon:SetPoint("TOPLEFT", MiniMapMailFrame, "TOPLEFT", 0, 0)
MiniMapMailIcon:SetPoint("BOTTOMRIGHT", MiniMapMailFrame, "BOTTOMRIGHT", 0, 0)
MiniMapMailIcon:SetVertexColor(1, 1, 1, 0.4)

-- zone text
local function GetZoneColor()
	local zoneType = GetZonePVPInfo()
	if (zoneType == 'sanctuary') then
		return 1, 1, 1, 0.8
	elseif (zoneType == 'arena') then
		return 1, 1, 1, 0.8
	elseif (zoneType == 'friendly') then
		return 1, 1, 1, 0.8
	elseif (zoneType == 'hostile') then
		return 1, 0.1, 0.1, 0.8
	elseif (zoneType == 'contested') then
		return 1, 1, 1, 0.8
	else
		return 1, 1, 1, 0.8
	end
end

local zone = Minimap:CreateFontString(nil, 'OVERLAY')
zone:SetFont([[Interface/AddOns/rMinimap/media/font/HOMIZIObold.ttf]], 12)
zone:SetPoint('top', Minimap, 0, -35)
zone:SetShadowOffset(1, -1)
zone:SetShadowColor(0, 0, 0)
zone:SetAlpha(1)
zone:SetSize(200, 10)
zone:SetJustifyH('CENTER')
zone:SetTextColor(GetZoneColor())
if GetSubZoneText() == '' then
	zone:SetText(GetZoneText())
else
	zone:SetText(GetSubZoneText())
end

Minimap:HookScript('OnUpdate', function()
	if GetSubZoneText() == '' then
		zone:SetText(GetZoneText())
	else
		zone:SetText(GetSubZoneText())
	end
	zone:SetTextColor(GetZoneColor())
end)

--zoom
Minimap:EnableMouseWheel()
local function Zoom(self, direction)
  if(direction > 0) then Minimap_ZoomIn()
  else Minimap_ZoomOut() end
end
Minimap:SetScript("OnMouseWheel", Zoom)

--onenter/show
local function Show()
  GameTimeFrame:SetAlpha(0.9)
  TimeManagerClockButton:SetAlpha(0.9)
  MiniMapTracking:SetAlpha(0.9)
  MiniMapChallengeMode:SetAlpha(0.9)
  MiniMapInstanceDifficulty:SetAlpha(0.9)
  GuildInstanceDifficulty:SetAlpha(0.9)
end
Minimap:SetScript("OnEnter", Show)

--onleave/hide
local lasttime = 0
local function Hide()
  if Minimap:IsMouseOver() then return end
  if time() == lasttime then return end
  GameTimeFrame:SetAlpha(0)
  TimeManagerClockButton:SetAlpha(0)
  MiniMapTracking:SetAlpha(0)
  MiniMapChallengeMode:SetAlpha(0)
  MiniMapInstanceDifficulty:SetAlpha(0)
  GuildInstanceDifficulty:SetAlpha(0)
end
local function SetTimer()
  lasttime = time()
  C_Timer.After(1.5, Hide)
end
Minimap:SetScript("OnLeave", Hide)
rLib:RegisterCallback("PLAYER_ENTERING_WORLD", Hide)
Hide(Minimap)


--drag frame
rLib:CreateDragFrame(MinimapCluster, L.dragFrames, -2, true)

--create slash commands
rLib:CreateSlashCmd(L.addonName, L.addonShortcut, L.dragFrames, L.addonColor)